// -*- Mode: C++ -*-
// Copyright (C) 2005 Aldo Nicolas Bruno

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef __HTTPCLIENT_H__
#define __HTTPCLIENT_H__
//class HTTPCResource;

#include "httpcresponse.h"
#include "inetsocket.h"


class HTTPClient
{

  INETSocket s;
  xstring my_host;
  int my_port;

  HTTPClient();
  
public:
  HTTPClient(const xstring& host, int port=0);

  int connect();

  HTTPCResource request(const xstring& method,const xstring& res, const xstringhash& headers, const xstring& data);

  xstring gethost() const;
  
  int getstatus()const;
};

#endif 
