// -*- Mode: C++ -*-
//
//    Object - an abstract base class for all objects..
//
//    Copyright (C) 2005 Aldo Nicolas Bruno
//
//    Linux Users Group San Fidenzio
//

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/ 

#ifndef __OBJECT_H__
#define __OBJECT_H__
#include "xstring.h"

class Object
{
  const xstring& my_name;
  int my_refcount;
  
public:
  Object(const xstring& name = "Object");
  virtual ~Object();
  void inc();
  void dec();
  xstring name() const {return my_name;};
};


#endif // __OBJECT_H__
