// -*- Mode: C++ -*-
//
// This file is part of the xstring test suite
//
//    Copyright (C) 2004 Aldo Nicolas Bruno
//
//    Linux Users Group San Fidenzio
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//

#include <xstring.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

void fail_test(const char* msg)
{
  fputs(msg,stdout);
  exit (1);
}

int main(int argc, char** argv)
{
  
  const xstr t="test1";
  xstring s(t);

  if(strcmp(t,s.text())) fail_test("const char* xstring::text(): ");
  if(strcmp(t,s.gets())) fail_test("const char* xstring::gets(): ");
  if(strcmp(t,s.c_str())) fail_test("const char* xstring::c_str(): ");

  std::string ss;
  ss=s.string();
  if(strcmp(ss.c_str(),s.text())) fail_test("std::string xstring::string(): ");

  char* u=s.duplicate();
  if(strcmp(s.text(),u)) fail_test("char* xstring::duplicate(): ");
  xstring::xstrfree(u);

  return 0;
}
